export declare type Key = string | number | Date | ArrayBufferView | ArrayBuffer | IDBArrayKey | IDBKeyRange;
export interface IndexDetails {
    indexName: string;
    order: string;
}
export declare function openDatabase(dbName: string, version: number, upgradeCallback?: Function): Promise<IDBDatabase>;
export declare function DBOperations(dbName: string, version: number, currentStore: string): {
    add<T>(value: T, key?: any): Promise<number>;
    getByID<T>(id: string | number): Promise<T>;
    getAll<T>(): Promise<T[]>;
    update<T>(value: T, key?: any): Promise<any>;
    deleteRecord(key: Key): Promise<any>;
    clear(): Promise<any>;
    openCursor(cursorCallback: (event: Event) => void, keyRange?: IDBKeyRange): Promise<void>;
    getByIndex(indexName: string, key: any): Promise<any>;
};
export declare enum DBMode {
    readonly = "readonly",
    readwrite = "readwrite"
}
